﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Intro_C_Sharp_3
{
    public partial class frm : Form
    {
        public frm()
        {
            InitializeComponent();
        }

        #region Automatic Properties
        
        private void btnAutoProp_Click(object sender, EventArgs e)
        {
            // regular properties use - (Class: regProp_Customer)
            // step into the object properties(using F11)
            regPropCustomer custRegProp = new regPropCustomer();
            custRegProp.CustomerID = 1;
            custRegProp.CustomerName = "Sara";

            // automatic properties use - (Class: autoProp_Customer)
            // step into the object properties(using F11)
            autoPropCustomer custAutoProp = new autoPropCustomer();
            custAutoProp.CustomerID = 2;
            custAutoProp.CustomerName = "Dan";
        }

        #endregion
        
        #region object initializer

        private void btnObjInit_Click(object sender, EventArgs e)
        {
            // old way to create and initialize objects
            autoPropCustomer oldCustomer = new autoPropCustomer();
            oldCustomer.CustomerID = 1;
            oldCustomer.CustomerName = "Armika.ltd";
            oldCustomer.City = "Tel Aviv";

            // using the new C# 3.0 object initializer
            autoPropCustomer newCustomer = new autoPropCustomer()
            {
                CustomerID = 2,
                CustomerName = "Armika.ltd",
                City = "Tel Aviv"
            };
        }

        #endregion

        #region Collection Initializer

        private void btnCollInit_Click(object sender, EventArgs e)
        {
            // initialize collections using object initializer
            List<autoPropCustomer> Customers = new List<autoPropCustomer>();

            Customers.Add(new autoPropCustomer() { CustomerID = 1, CustomerName = "Hod Ami" });
            Customers.Add(new autoPropCustomer() { CustomerID = 2, CustomerName = "Matrix" });
            Customers.Add(new autoPropCustomer() { CustomerID = 3, CustomerName = "Leumi" });

            // short way to initialize collection using the collection initializer
            List<autoPropCustomer> CustomersList = new List<autoPropCustomer>()
            {
                new autoPropCustomer() { CustomerID=1,CustomerName ="Hod Ami" },
                new autoPropCustomer() { CustomerID = 2, CustomerName = "Matrix" },
                new autoPropCustomer() { CustomerID = 3, CustomerName = "Leumi" }
            };

        }

        #endregion

        #region Implicitly typed local variable (var)
        
        private void btnVar_Click(object sender, EventArgs e)
        {
            // using the new var keyword
            var intValue = 3;
            var stringValue = "Hello";
            var doubleValue = 1.0;
            var arrayNumbers = new int[] { 1, 2, 3 };
            var customer = new autoPropCustomer();
        }
        
        #endregion

        #region Extension methods

        private void btnExtMethod_Click(object sender, EventArgs e)
        {
            // using the Extension method 
            // you can find the Reverse method inside the stringUtils class.
            var s = "C# 3.0 is Cool!!!";
            MessageBox.Show(s.Reverse());
        }

        #endregion

        #region  Anonymous Types

        private void btnAnonymousType_Click(object sender, EventArgs e)
        {
            // using Anonymous Types
            // the old way:
            /*
             public class Customer
            {
                public int CustomerID { get; set; }
                public string CustomerName { get; set; }
                public string ContactName { get; set; }
                public string City { get; set; }
            }

            class Program
            {
                static void Main(string[] args)
                {
                    Customer aCust = new Customer();
                    ...
                
                }
            }*/

            // the new way (using object initializer + the new var keyword)
            var aCust = new { CustomerID = "1", CustomerName = "Armika.ltd", ContactName = "Jacob" };
            MessageBox.Show(aCust.CustomerName);
        }

        #endregion

        #region LambdaExpression

        delegate double MyDel(int par);

        private void btnLambdaExp_Click(object sender, EventArgs e)
        {
            MyDel le4 = x => x + 1;
            MessageBox.Show(le4(12).ToString());
        }

        #endregion
       
    }
}
