﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Intro_to_LINQ
{
    class Program
    {
        static void Main(string[] args)
        {
            sample1();
            // sample2();
            // sample3();
            // sample4();
            // sample5();
            // sample6();
            // sample7();
            // sample8();
            // sample9();
            // sample10();
            // sample11();

        }

        static void sample11()
        {
            var myNumbers = new[] { 1, 2, 3 };

            int myTotalNumbers = myNumbers.Sum();
            int myNumbersQuantity = myNumbers.Count();

            Console.WriteLine("I have {0} numbers, and their sum = {1}"
                                        , myNumbersQuantity, myTotalNumbers);
        }

        static void sample10()
        {
            var arr1 = new[] { 1, 3, 4 };
            var arr2 = new[] { 1, 4, 6 };

            var query = from a1 in arr1
                        join a2 in arr2 on a1 equals a2
                        into arr1_2
                        from x in arr1_2
                        select x;

            foreach (var a in query)
                Console.WriteLine("{0}", a);

        }

        static void sample9() {

            var products = new[]      
            {  
                new {ProductID = 1, ProductName = "milki",   Category = "Dairy"},
                new {ProductID = 2, ProductName = "Dani",    Category = "Dairy"},
                new {ProductID = 3, ProductName = "yogurt",  Category = "Dairy"},
                new {ProductID = 4, ProductName = "chicken", Category = "Meat"},
                new {ProductID = 5, ProductName = "steak",   Category = "Meat"}
            };

            var groupProducts = from product in products
                                group product by product.Category;

            foreach (var p in groupProducts)
            {
                Console.WriteLine("{0}", p.Key);

                foreach (var gp in p)
                    Console.WriteLine("    {0}. {1}", gp.ProductID, gp.ProductName);

            }

        }

        static void sample8()
        {
            var products = new[]  // מערך של סוג אנונימי
            {  
                new {ProductID = 1, ProductName = "Bamba", Price=3.40d},
                new {ProductID = 2, ProductName = "Bisli", Price=3.60d},
                new {ProductID = 3, ProductName = "Beigale", Price=3.50d}
            };

            var sortProducts = from product in products
                               orderby product.Price  // מיון לפי מחיר
                               select product;

            foreach (var p in sortProducts)
            {
                Console.WriteLine("{0}. {1},   {2}"
                            , p.ProductID, p.ProductName, p.Price);
            }

        }

        static void sample7()
        {
            var products = new[]  // מערך של סוג אנונימי
            {  
                new {ProductID = 1, ProductName = "Bamba", Price=3.40d},
                new {ProductID = 2, ProductName = "Bisli", Price=3.60d},
                new {ProductID = 3, ProductName = "Beigale", Price=3.90d}
            };

            var sortProducts = from product in products
                               orderby product.Price  // מיון לפי מחיר
                               select product;

            foreach (var p in sortProducts)
            {
                Console.WriteLine("{0}. {1},   {2}"
                            , p.ProductID, p.ProductName, p.Price);
            }

        }

        static void sample6()
        {
            var arr1 = new[] { 1, 3, 5 };
            var arr2 = new[] { 2, 5, 4 };

            var newArr = from a1 in arr1
                         from a2 in arr2
                         let sum = a1 + a2
                         where sum <= 10   // תנאי ראשון
                         where a1 == 5     // תנאי שני
                         select new { a1, a2, sum };

            foreach (var a in newArr)
            {
                Console.WriteLine(a);
            }
        }
        
        static void sample5() 
        {
            var arr1 = new[] { 1, 3, 5 };
            var arr2 = new[] { 2, 5, 7 };

            var newArr = from a1 in arr1
                         from a2 in arr2
                         let sum = a1 + a2  // אחסון התוצאות במשתנה חדש
                         where sum == 10
                         select new { a1, a2, sum };

            foreach (var a in newArr)
            {
                Console.WriteLine(a);
            }
        }

        static void sample4()
        {
            var arr1 = new[] { 1, 3, 5 };
            var arr2 = new[] { 2, 4, 6 };

            var newArr = from a1 in arr1
                         from a2 in arr2
                         where a1 > 2 && a2 < 5
                         select new { a1, a2, sum = a1 + a2 };

            foreach (var a in newArr)
            {
                Console.WriteLine(a);
            }
        }

        static void sample3()
        {
            int[] grades = { 100, 90, 55, 60, 82, 75 };

            var goodGrades = from grade in grades   // grade – משתנה איטרציה
                             where grade > 75
                             select grade;

            foreach (var grade in goodGrades)
                Console.Write("{0}, ", grade);

        }

        static void sample2()
        {
            int[] numbers = { 9, 2, 3, 4, 1, 15, 6, 22 };

            //	תחביר שאילתא 
            var pairNumbers1 = from n in numbers
                               where n % 2 == 0
                               select n;

            // תחביר שיטה
            var pairNumbers2 = numbers.Where(x => x % 2 == 0);

            // תחביר משולב
            int pairNumbersCount = (from n in numbers
                                    where n % 2 == 0
                                    select n).Count();

            foreach (var x in pairNumbers1)
                Console.Write("{0}, ", x);
            Console.WriteLine();


            foreach (var x in pairNumbers2)
                Console.Write("{0}, ", x);
            Console.WriteLine();

            Console.WriteLine(pairNumbersCount);
        }

        static void sample1()
        {
            // מקור הנתונים
            int[] numbers = { 11, 2, 3, 5, 1, 15, 6, 22 };

            // underTenהגדרת ושמירת השאילתא במשתנה   
            IEnumerable<int> underTen =
                            from n in numbers
                            where n < 10
                            select n;

            // ביצוע (הפעלה) של השאילתא
            foreach (var x in underTen)
                Console.Write("{0}, ", x);

        }
    }
}
